<?php

/**
 *  Реализация связи модуля с Views
 */


/**
 * Реализует hook_views_data() 
 * рассказывает модулю Views про нашу таблицу
 * 
 * @return array - информация о таблицах
 */
function mytest_views_data() {
  $data = array();

  $data['testnode'] = array(
    'table' => array(
      'group' => t('Testnode'),
    ),
    'tid' => array(
      'title' => t('Test Node ID'),
      'field' => array(
        'handler' => 'views_handler_field',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
    ),
    'nid' => array(
      'title' => t('Node ID'),
      'field' => array(
        'handler' => 'views_handler_field',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
    ),
    'int_count' => array(
      'title' => t('Count'),
      'field' => array(
        'handler' => 'views_handler_field',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
    ),
    'int_total' => array(
      'title' => t('Total'),
      'field' => array(
        'handler' => 'views_handler_field',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
    ),
  );
  $data['testnode']['percentage'] = array(
    'title' => t('Percentage'),
    'field' => array(
      'handler' => 'mytest_handler_field_percentage',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_formula',
      'formula' => 'ROUND(testnode.int_count*100/testnode.int_total)',
    ),
    'filter' => array(
      'handler' => 'mytest_handler_filter_percentage',
    ),
  );
  //join to node
  $data['testnode']['table']['join']['node'] = array(
    'left_field' => 'nid',
    'field'	=> 'nid',
  );
  return $data; 
} //function mytest_views_data


/**
 * Реализует hook_views_handlers
 * создает хэндлеры для нашего виртуального поля percentage
 * 
 * @return array - информация о хэндлерах
 */
function mytest_views_handlers() {
  $handlers = array();
  
  $handlers['handlers']['mytest_handler_field_percentage'] = array(
    'parent' => 'views_handler_field_numeric',
    'file' => 'mytest_handler_field_percentage.inc',
  );
  
  $handlers['handlers']['mytest_handler_filter_percentage'] = array(
    'parent' => 'views_handler_filter_numeric',
    'file' => 'mytest_handler_filter_percentage.inc',
  );
  
  return $handlers;
} //function mytest_views_handlers
